<!--startmeta
custom_edit_url: "https://github.com/netdata/go.d.plugin/edit/master/modules/logstash/README.md"
meta_yaml: "https://github.com/netdata/go.d.plugin/edit/master/modules/logstash/metadata.yaml"
sidebar_label: "Logstash"
learn_status: "Published"
learn_rel_path: "Data Collection/Logs Servers"
message: "DO NOT EDIT THIS FILE DIRECTLY, IT IS GENERATED BY THE COLLECTOR'S metadata.yaml FILE"
endmeta-->

# Logstash

Plugin: go.d.plugin
Module: logstash

<img src="https://img.shields.io/badge/maintained%20by-Netdata-%2300ab44" />

## Overview

This collector monitors Logstash instances.




This collector is supported on all platforms.

This collector supports collecting metrics from multiple instances of this integration, including remote instances.


### Default Behavior

#### Auto-Detection

This integration doesn't support auto-detection.

#### Limits

The default configuration for this integration does not impose any limits on data collection.

#### Performance Impact

The default configuration for this integration is not expected to impose a significant performance impact on the system.


## Metrics

Metrics grouped by *scope*.

The scope defines the instance that the metric belongs to. An instance is uniquely identified by a set of labels.



### Per Logstash instance

These metrics refer to the entire monitored application.

This scope has no labels.

Metrics:

| Metric | Dimensions | Unit |
|:------|:----------|:----|
| logstash.jvm_threads | threads | count |
| logstash.jvm_mem_heap_used | in_use | percentage |
| logstash.jvm_mem_heap | committed, used | KiB |
| logstash.jvm_mem_pools_eden | committed, used | KiB |
| logstash.jvm_mem_pools_survivor | committed, used | KiB |
| logstash.jvm_mem_pools_old | committed, used | KiB |
| logstash.jvm_gc_collector_count | eden, old | counts/s |
| logstash.jvm_gc_collector_time | eden, old | ms |
| logstash.open_file_descriptors | open | fd |
| logstash.event | in, filtered, out | events/s |
| logstash.event_duration | event, queue | seconds |
| logstash.uptime | uptime | seconds |

### Per pipeline

These metrics refer to the pipeline.

Labels:

| Label      | Description     |
|:-----------|:----------------|
| pipeline | pipeline name |

Metrics:

| Metric | Dimensions | Unit |
|:------|:----------|:----|
| logstash.pipeline_event | in, filtered, out | events/s |
| logstash.pipeline_event | event, queue | seconds |



## Alerts

There are no alerts configured by default for this integration.


## Setup

### Prerequisites

No action required.

### Configuration

#### File

The configuration file name for this integration is `go.d/logstatsh.conf`.


You can edit the configuration file using the `edit-config` script from the
Netdata [config directory](https://github.com/netdata/netdata/blob/master/docs/configure/nodes.md#the-netdata-config-directory).

```bash
cd /etc/netdata 2>/dev/null || cd /opt/netdata/etc/netdata
sudo ./edit-config go.d/logstatsh.conf
```
#### Options

The following options can be defined globally: update_every, autodetection_retry.


<details><summary>Config options</summary>

| Name | Description | Default | Required |
|:----|:-----------|:-------|:--------:|
| update_every | Data collection frequency. |  | False |
| autodetection_retry | Recheck interval in seconds. Zero means no recheck will be scheduled. |  | False |
| url | Server URL. |  | True |
| timeout | HTTP request timeout. |  | False |
| username | Username for basic HTTP authentication. |  | False |
| password | Password for basic HTTP authentication. |  | False |
| proxy_url | Proxy URL. |  | False |
| proxy_username | Username for proxy basic HTTP authentication. |  | False |
| proxy_password | Password for proxy basic HTTP authentication. |  | False |
| method | HTTP request method. |  | False |
| body | HTTP request body. |  | False |
| headers | HTTP request headers. |  | False |
| not_follow_redirects | Redirect handling policy. Controls whether the client follows redirects. |  | False |
| tls_skip_verify | Server certificate chain and hostname validation policy. Controls whether the client performs this check. |  | False |
| tls_ca | Certification authority that the client uses when verifying the server's certificates. |  | False |
| tls_cert | Client TLS certificate. |  | False |
| tls_key | Client TLS key. |  | False |

</details>

#### Examples

##### Basic

A basic example configuration.

<details><summary>Config</summary>

```yaml
jobs:
  - name: local
    url: http://localhost:9600

```
</details>

##### HTTP authentication

HTTP authentication.

<details><summary>Config</summary>

```yaml
jobs:
  - name: local
    url: http://localhost:9600
    username: username
    password: password

```
</details>

##### HTTPS with self-signed certificate

HTTPS and self-signed certificate.

<details><summary>Config</summary>

```yaml
jobs:
  - name: local
    url: https://localhost:9600
    tls_skip_verify: yes

```
</details>

##### Multi-instance

> **Note**: When you define multiple jobs, their names must be unique.

Collecting metrics from local and remote instances.


<details><summary>Config</summary>

```yaml
jobs:
  - name: local
    url: http://localhost:9600

  - name: remote
    url: http://192.0.2.1:9600

```
</details>



## Troubleshooting

### Debug Mode

To troubleshoot issues with the `logstash` collector, run the `go.d.plugin` with the debug option enabled. The output
should give you clues as to why the collector isn't working.

- Navigate to the `plugins.d` directory, usually at `/usr/libexec/netdata/plugins.d/`. If that's not the case on
  your system, open `netdata.conf` and look for the `plugins` setting under `[directories]`.

  ```bash
  cd /usr/libexec/netdata/plugins.d/
  ```

- Switch to the `netdata` user.

  ```bash
  sudo -u netdata -s
  ```

- Run the `go.d.plugin` to debug the collector:

  ```bash
  ./go.d.plugin -d -m logstash
  ```


